#!/usr/bin/env bash

function miner_ver() {
  local MINER_VER=$TON_POOL_MINER_VER
  [[ -z $MINER_VER ]] && MINER_VER=$MINER_LATEST_VER
  echo $MINER_VER
}

function miner_config_echo() {
  local MINER_VER=`miner_ver`
  miner_echo_config_file "$MINER_DIR/$MINER_VER/miner.conf"
}

function miner_config_gen() {
  local MINER_CONFIG="$MINER_DIR/$MINER_VER/miner.conf"
  mkfile_from_symlink $MINER_CONFIG

  [[ -z $TON_POOL_MINER_TEMPLATE ]] && echo -e "${YELLOW}TON_POOL_MINER_TEMPLATE is empty${NOCOLOR}" && return 1
  [[ -z $TON_POOL_MINER_URL ]] && echo -e "${YELLOW}TON_POOL_MINER_URL is empty${NOCOLOR}" && return 2

  local conf=
  local POOLS=()
  for pool_url in $TON_POOL_MINER_URL; do
    POOLS+=("$pool_url")
  done
  conf+="POOLS=( ${POOLS[@]} )"$'\n'
  conf+="CONFIG=\"$TON_POOL_MINER_USER_CONFIG\""$'\n'
  conf+="WALLET=\"$TON_POOL_MINER_TEMPLATE\""$'\n'

  echo "$conf" > $MINER_CONFIG
}
