#!/usr/bin/env bash

cd $MINER_DIR/$MINER_VER
export LD_LIBRARY_PATH=.

MINER_LOG_BASEDIR=`dirname "$MINER_LOG_BASENAME"`
[[ ! -d $MINER_LOG_BASEDIR ]] && mkdir -p $MINER_LOG_BASEDIR

touch $MINER_LOG_BASENAME.log

# remove tmp dirs
while read -r d; do
  [[ "$d" =~ (\/tmp\/[^\\]+)\/solvers ]] && echo "Removing ${BASH_REMATCH[1]}" && rm -r "${BASH_REMATCH[1]}"
done < <( realpath /tmp/*/solvers 2>/dev/null )

source ${MINER_DIR}/${MINER_VER}/miner.conf

AMDCNT=`gpu-detect AMD`
NVCNT=`gpu-detect NVIDIA`

rmfile_from_symlink benchmark_data.txt; mkfile_from_symlink benchmark_data.txt

for pool in "${POOLS[@]}"; do
  echo "Using ${WHITE}$pool${NOCOLOR}"
  wd delay $(( (AMDCNT+NVCNT)*5 + 1 ))
  #usage: miner-linux [-h] [-p PLATFORM] [-d DEVICE] [-t THREADS] [--stats] [--stats-devices] [--debug] [--silent] POOL WALLET
  rmfile_from_symlink stats.json; mkfile_from_symlink stats.json
  rmfile_from_symlink devices.json; mkfile_from_symlink devices.json
  ./miner-linux --stats --stats-devices $CONFIG $pool $WALLET 2>&1 | tee --append $MINER_LOG_BASENAME.log
  [[ $? -gt 127 ]] && break
done
