#!/usr/bin/env bash
LOAD_LIMIT=5
STATS_FILE="/run/hive/miners/ton-pool-miner/stats.json"
DEVICE_FILE="/run/hive/miners/ton-pool-miner/devices.json"
algo="sha256"

khs=0
stats=0
gpu_stats=$(< $GPU_STATS_JSON)

#readarray -t gpu_stats < <( jq --slurp -r -c '.[] | .busids, .brand, .temp, .fan, .power, .load | join(" ")' $GPU_STATS_JSON 2>/dev/null)
readarray -t gpu_stats < <( jq --slurp -r -c '.[] | .busids, .brand, .temp, .fan | join(" ")' $GPU_STATS_JSON 2>/dev/null)
busids=(${gpu_stats[0]})
brands=(${gpu_stats[1]})
temps=(${gpu_stats[2]})
fans=(${gpu_stats[3]})
#power=(${gpu_stats[4]})
#load=(${gpu_stats[5]})
count=${#busids[@]}

hash_arr=()
busid_arr=()
fan_arr=()
temp_arr=()
found=0
uptime=0
khs=0
hashes=()
cards=()
miner_stats=()

if [[ -f $STATS_FILE && `stat -c %Y $STATS_FILE` -gt $((`date +%s`-60)) ]]; then
  #{"total": 1032511.980703688, "rates": [380.95794498429944, 651.5540357193886], "uptime": 93.03816103935242, "accepted": 0, "rejected": 0}
  readarray -t miner_stats < <( jq -r '(.uptime|floor),(.accepted|floor),(.rejected|floor),(.total|floor),([.rates|.[]|floor|tostring]|join(" "))' $STATS_FILE )
  uptime=${miner_stats[0]}
  ac=${miner_stats[1]}
  rj=${miner_stats[2]}
  khs=${miner_stats[3]}
  hash_arr=( ${miner_stats[4]} )
  busid_arr=( `jq -r '([.[].bus|floor|tostring]|join(" "))' $DEVICE_FILE` )
else
  echo "No stats"
fi

for(( i=0; i < count; i++ )); do
  for(( j=0; j < count; j++ )); do
    #[[ "${brands[i]}" == "cpu" ]] && continue
    [[ "${busids[j]}" =~ ^([A-Fa-f0-9]+): ]]
    [[ $((16#${BASH_REMATCH[1]})) != ${busid_arr[i]} ]] && continue
    temp_arr+=(${temps[j]})
    fan_arr+=(${fans[j]})
  done
done

hash_json=`printf '%s\n' "${hash_arr[@]}" | jq -cs '.'`
bus_numbers=`printf '%s\n' "${busid_arr[@]}" | jq -cs '.'`
fan_json=`printf '%s\n' "${fan_arr[@]}" | jq -cs '.'`
temp_json=`printf '%s\n' "${temp_arr[@]}" | jq -cs '.'`

# uptime
#if [[ $uptime -eq 0 ]]; then
#  readarray -t pids < <( pgrep danila-miner )
#  [[ ! -z ${pids[0]} && -e /proc/${pids[0]} ]] &&
#    uptime=$(( `date +%s` - `stat -c%X /proc/${pids[0]}` ))
#fi

stats=$(jq -ns \
        --arg ac "$ac" --arg rj "$rj" --arg algo "$algo" --argjson bus_numbers "$bus_numbers" --argjson fan "$fan_json" \
        --argjson temp "$temp_json" --argjson hs "$hash_json" --arg uptime "$uptime" --arg ver "$CUSTOM_VERSION" \
        '{$hs, hs_units: "mhs", $algo, $ver, $uptime, $bus_numbers, $temp, $fan, ar:[$ac|tonumber, $rj|tonumber]}')

echo $khs
echo $stats
